#pragma once
#include <windows.h>

typedef void (*MovementFuncType)(int& x, int& y);


typedef long (CALLBACK *MyWindowProcType)(HWND hDlg, UINT message, WPARAM wParam, 
										  LPARAM lParam);

long CALLBACK myDefaultWinProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

void clientAreaOrg(POINT& point, HWND hwnd=NULL);


const int MaxWindowProcCount=256;

struct MyWindow
{
	WNDCLASSEX  wndClass;
	HINSTANCE hGlobalInstance;
	HWND hGlobalWnd;
	RECT myRect;
	//int clientOrgX, clientOrgY;
	//int left, top;
	int myShowCmd;
	char windowTitle[80];
	char errMsg[256];
	int width, height;
	bool fullScreen;
	void init(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpComdLine, int nShowCmd);
	MyWindowProcType myWindowProcArray[MaxWindowProcCount];
	int myWindowProcCount;
	bool registerMyWindowProc(MyWindowProcType myNewWindowProc);
	bool unRegisterMyWindowProc(MyWindowProcType myOldWindowProc);

	BOOL mainLoop();
};

extern MyWindow myWindow;