#include <windows.h>
#include "sprite.h"



struct AnimationMan: public Animation
{
	virtual void drawAnimation(HWND hwnd, int myX, int myY, unsigned int elapseTime);
};

AnimationMan animationMan;

VOID __stdcall animationTimerFunc(
	HWND hwnd,         // handle to window
	UINT uMsg,         // WM_TIMER message
	UINT idEvent,  // timer identifier
	DWORD dwTime       // current system time
)
{
	animationMan.draw(hwnd);
} 	



void AnimationMan::drawAnimation(HWND hwnd, int myX, int myY, unsigned int elapseTime)
{
	//TIMERPROC timerProc;
	Animation::drawAnimation(hwnd, myX, myY, elapseTime);
	SetTimer(hwnd, myTimerID, elapseTime, animationTimerFunc);
}



long CALLBACK drawAnimationMan(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int x, y;
	switch (message)
	{
	case WM_CREATE:
		//		
		animationMan.init(hwnd, "archer+female-bow-attack", true, false);
		
		break;
	case WM_LBUTTONDOWN:
		/*
		x=LOWORD(lParam);
		y=HIWORD(lParam);
		//animationMan.drawAnimation(hwnd, x, y, 20);
		animationMan.sprite[0].drawSprite(hwnd, x, y);
		animationMan.sprite[0].halfBright(hwnd, x, y);
		*/

		x=LOWORD(lParam);
		y=HIWORD(lParam);
		animationMan.sprite[0].drawSprite(hwnd, x, y);

		break;
	case WM_RBUTTONDOWN:
		/*
		x=LOWORD(lParam);
		y=HIWORD(lParam);
		//animationMan.drawAnimation(hwnd, x, y, 20);
		animationMan.sprite[0].drawSprite(hwnd, x, y);
		animationMan.sprite[0].doubleBright(hwnd, x, y);
		*/

		break;
	}
	return 0L;
}



